! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
!--------------------------------------------------------------------
program checkoutput
!--------------------------------------------------------------------
! test if output sensitivity image deviates by more than 1 % 
! from reference image

use dal
use errorhandling

implicit none

real(kind=single) :: frac
integer(kind=int32) :: ix, iy
type(DataSetT)  :: set1, set2
type(ArrayT)    :: arr1, arr2

real(kind=single), dimension(:,:), pointer :: test, ref
logical ok

set1 = dataSet("sens_map1.fits", read)
arr1 = array(set1, "PRIMARY",read)

set2 = dataSet("sens_map1.ref", read)
arr2 = array(set2, "PRIMARY",read)

test => real32Array2Data(arr1)
ref  => real32Array2Data(arr2)

ok = .true.

do ix=20,180,10
  do iy=20,180,10
    if (ref(ix,iy) > 0.0) then
      frac = test(ix,iy)/ref(ix,iy)
      if (frac < 0.8 .or. frac > 1.2) then
        ok = .false.
        print *,ix,iy,test(ix,iy),ref(ix,iy)
      end if
    end if
  end do
end do

call release(arr1)
call release(arr2)
call release(set1)
call release(set2)

if (.not.ok) call error("test failed","sensitivity image contains wrong values")

end program checkoutput

